<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\training;


use app\common\model\training\TrainingWorkerCourse;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * TrainingWorkerCourse逻辑
 * Class TrainingWorkerCourseLogic
 * @package app\adminapi\logic
 */
class TrainingWorkerCourseLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/16 16:44
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            TrainingWorkerCourse::create([
                'master_worker_id' => $params['master_worker_id'],
                'training_task_id' => $params['training_task_id'],
                'training_course_id' => $params['training_course_id'],
                'play_time' => $params['play_time'],
                'exam_start_time' => $params['exam_start_time'],
                'exam_end_time' => $params['exam_end_time'],
                'study_status' => $params['study_status'],
                'question_all_score' => $params['question_all_score'],
                'question_qualified_score' => $params['question_qualified_score'],
                'exam_score' => $params['exam_score'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/16 16:44
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            TrainingWorkerCourse::where('id', $params['id'])->update([
                'master_worker_id' => $params['master_worker_id'],
                'training_task_id' => $params['training_task_id'],
                'training_course_id' => $params['training_course_id'],
                'play_time' => $params['play_time'],
                'exam_start_time' => $params['exam_start_time'],
                'exam_end_time' => $params['exam_end_time'],
                'study_status' => $params['study_status'],
                'question_all_score' => $params['question_all_score'],
                'question_qualified_score' => $params['question_qualified_score'],
                'exam_score' => $params['exam_score'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/16 16:44
     */
    public static function delete(array $params): bool
    {
        return TrainingWorkerCourse::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2025/02/16 16:44
     */
    public static function detail($params): array
    {
        return TrainingWorkerCourse::findOrEmpty($params['id'])->toArray();
    }
}